Codeforces Round #275 (Div. 1)D(树形DP)_html/css_WEB-ITnose
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output
You have a rooted tree consisting of n vertices. Let's number them with integers from 1 to n inclusive. The root of the tree is the vertex 1. For each i?>?1 direct parent of the vertex i is pi. We say that vertex i is child for its direct parent pi.
You have initially painted all the vertices with red color. You like to repaint some vertices of the tree. To perform painting you use the function paint that you call with the root of the tree as an argument. Here is the pseudocode of this function:
count = 0 // global integer variable rnd() { // this function is used in paint code return 0 or 1 equiprobably}paint(s) { if (count is even) then paint s with white color else paint s with black color count = count + 1 if rnd() = 1 then children = [array of vertex s children in ascending order of their numbers] else children = [array of vertex s children in descending order of their numbers] for child in children { // iterating over children array if rnd() = 1 then paint(child) // calling paint recursively }}
As a result of this function, some vertices may change their colors to white or black and some of them may remain red.
Your task is to determine the number of distinct possible colorings of the vertices of the tree. We will assume that the coloring is possible if there is a nonzero probability to get this coloring with a single call of paint(1). We assume that the colorings are different if there is a pair of vertices that are painted with different colors in these colorings. Since the required number may be very large, find its remainder of division by 1000000007 (109?+?7).
Input
The first line contains a single integer n (2?≤?n?≤?105) ? the number of vertexes in the tree.
The second line contains n?-?1 integers p2,?p3,?...,?pn (1?≤?pi?
Output
Print a single integer ? the answer to the problem modulo 1000000007 (109?+?7)
Sample test(s)
input
41 2 1
output
input
31 1
output
Note
All possible coloring patterns of the first sample are given below.
题意:RT
思路:首先看到这个函数不要被吓到,实际上就是求多少种子树
dp[u][0]表示以u为根,子树大小为偶数的方案数
dp[u][1]表示以u为根,子树大小为奇数的方案数
这样是按升序算的结果,将这个乘2可以得到升序+降序的结果,但是中间会有部分算重
考虑这样两种情况
1.如果u的每个孩子大小都为偶数,那么选任意数量的孩子的这种情况都是重复了
2.如果u的每个孩子大小都为奇数,那么选任意奇数数量的孩子的这种情况也是重复了(自己画一下图就知道了)
细节看代码~
推荐阅读
-
Codeforces Round #272 (Div. 1)D(字符串DP)_html/css_WEB-ITnose
-
Codeforces Round #256 (Div. 2)D 二分答案_html/css_WEB-ITnose
-
Codeforces Round #132 (Div. 2) D. Hot Days_html/css_WEB-ITnose
-
Codeforces Round #274 (Div. 2) D. Long Jumps_html/css_WEB-ITnose
-
Codeforces Round #274 (Div. 2) E. Riding in a Lift(DP)_html/css_WEB-ITnose
-
Codeforces Round #275 (Div. 1)C(状压+期望)_html/css_WEB-ITnose
-
Codeforces Round #276 (Div. 1)B(暴力)_html/css_WEB-ITnose
-
Codeforces Round #FF (Div. 1)-A,B,C_html/css_WEB-ITnose
-
Codeforces Round #250 (Div. 1)B(排序+并查集)_html/css_WEB-ITnose
-
Codeforces Round #275 (Div. 1)D(树形DP)_html/css_WEB-ITnose